package inf101.v18.connectfour.events.random;

import inf101.v18.connectfour.board.IVerticalBoard;
import inf101.v18.connectfour.objects.Empty;
import inf101.v18.connectfour.objects.Immovable;

/**
 * Blocks a random tile on the board
 */
public class Block extends RandomEvent {
    @Override
    void act(IVerticalBoard b) {
        int i;
        do {
            i = random.nextInt(b.getWidth());
        } while (!b.isFull() && !(b.get(i, b.getHeight()-1) instanceof Empty));
        b.drop(i, new Immovable());
    }

    @Override
    public String announcement() {
        return "An immovable object was placed.";
    }
}
