package inf101.v18.connectfour.objects;

import inf101.v18.connectfour.player.IPlayer;

/**
 * A token represents an object a player can place on a board.
 */
public class Token extends GameObject implements IPlayerObject {
    private final IPlayer owner;

    public Token(IPlayer owner) {
        this.owner = owner;
        this.color = owner.getColor();
    }

    /**
     * Fetches the player associated with the token.
     *
     * @return  A player
     */
    public IPlayer getOwner() {
        return this.owner;
    }
}
