package inf101.v18.connectfour;

import inf101.v18.connectfour.board.VerticalBoard;
import inf101.v18.connectfour.events.winning.FourInARow;
import inf101.v18.connectfour.events.winning.IWinCondition;
import inf101.v18.connectfour.objects.Empty;
import inf101.v18.connectfour.objects.IPlayerObject;
import inf101.v18.connectfour.objects.Token;
import inf101.v18.connectfour.player.Player;
import org.junit.Test;

import java.awt.*;
import java.util.ArrayList;
import java.util.List;

import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

public class FourInARowTest {
    private final List<IWinCondition> conditions = new ArrayList<>();

    @Test
    public void horisontalTest() {
        conditions.add(new FourInARow());
        VerticalBoard board = new VerticalBoard(4, 1, new Empty(), conditions);
        IPlayerObject token = new Token(new Player("Naem", Color.RED));
        assertTrue(board.drop(0, token));
        assertFalse(board.won());
        assertTrue(board.drop(1, token));
        assertFalse(board.won());
        assertTrue(board.drop(2, token));
        assertFalse(board.won());
        assertTrue(board.drop(3, token));
        assertTrue(board.won());
    }

    @Test
    public void verticalTest() {
        conditions.add(new FourInARow());
        VerticalBoard board = new VerticalBoard(1, 4, new Empty(), conditions);
        IPlayerObject token = new Token(new Player("Naem", Color.RED));
        assertTrue(board.drop(0, token));
        assertFalse(board.won());
        assertTrue(board.drop(0, token));
        assertFalse(board.won());
        assertTrue(board.drop(0, token));
        assertFalse(board.won());
        assertTrue(board.drop(0, token));
        assertTrue(board.won());
    }

    @Test
    public void diagonalTest() {
        conditions.add(new FourInARow());
        VerticalBoard board = new VerticalBoard(10, 10, new Empty(), conditions);
        IPlayerObject token1 = new Token(new Player("Naem", Color.RED));
        IPlayerObject token2 = new Token(new Player("Name", Color.GREEN));
        board.drop(0, token1);
        board.drop(1, token2);
        board.drop(1, token1);
        board.drop(3, token2);
        board.drop(3, token1);
        board.drop(3, token2);
        board.drop(3, token1);
        board.drop(2, token2);
        board.drop(2, token2);
        assertFalse(board.won());
        board.drop(2, token1);
        assertTrue(board.won());
    }
}
