package inf101.v18.connectfour;

import inf101.v18.connectfour.board.IVerticalBoard;
import inf101.v18.connectfour.board.VerticalBoard;
import inf101.v18.connectfour.events.random.Block;
import inf101.v18.connectfour.events.random.Bomb;
import inf101.v18.connectfour.events.random.IRandomEvent;
import inf101.v18.connectfour.objects.Empty;
import inf101.v18.connectfour.objects.Immovable;
import inf101.v18.connectfour.objects.Token;
import inf101.v18.connectfour.player.Player;
import org.junit.Test;

import java.awt.*;
import java.util.ArrayList;

import static org.junit.Assert.assertEquals;

public class RandomEventTest {
    @Test
    public void bombTest() {
        IVerticalBoard board = new VerticalBoard(1, 1, new Empty(), new ArrayList<>());
        IRandomEvent bomb = new Bomb();
        board.drop(0, new Token(new Player("AAA", Color.MAGENTA)));
        assertEquals(Token.class, board.get(0,0).getClass());
        boolean flipped;
        do {
            flipped = bomb.flipCoin(board);
        } while (!flipped);
        assertEquals(Empty.class, board.get(0,0).getClass());
    }

    @Test
    public void immovableTest() {
        IVerticalBoard board = new VerticalBoard(1, 1, new Empty(), new ArrayList<>());
        IRandomEvent immovable = new Block();
        assertEquals(Empty.class, board.get(0,0).getClass());
        boolean flipped;
        do {
            flipped = immovable.flipCoin(board);
        } while (!flipped);
        assertEquals(Immovable.class, board.get(0,0).getClass());
    }
}