package inf101.v18.connectfour;

import inf101.v18.connectfour.board.Board;
import inf101.v18.connectfour.events.winning.IWinCondition;
import inf101.v18.connectfour.events.winning.ThreeInARow;
import inf101.v18.connectfour.objects.Empty;
import inf101.v18.connectfour.objects.IPlayerObject;
import inf101.v18.connectfour.objects.Token;
import inf101.v18.connectfour.player.Player;
import org.junit.Assert;
import org.junit.Test;

import java.awt.*;
import java.util.ArrayList;
import java.util.List;

public class TicTacToeTest {
    private final List<IWinCondition> conditions = new ArrayList<>();

    @Test
    public void horisontalTest() {
        conditions.add(new ThreeInARow());
        Board board = new Board(3, 3, new Empty(), conditions);
        IPlayerObject token = new Token(new Player("Naem", Color.WHITE));
        board.set(0, 0, token);
        board.set(1, 0, token);
        board.set(2, 0, token);
        Assert.assertTrue(board.won());
        board = new Board(3, 3, new Empty(), conditions);
        board.set(0, 1, token);
        board.set(1, 1, token);
        board.set(2, 1, token);
        Assert.assertTrue(board.won());
        board = new Board(3, 3, new Empty(), conditions);
        board.set(0, 2, token);
        board.set(1, 2, token);
        board.set(2, 2, token);
        Assert.assertTrue(board.won());
    }

    @Test
    public void verticalTest() {
        conditions.add(new ThreeInARow());
        Board board = new Board(3, 3, new Empty(), conditions);
        IPlayerObject token = new Token(new Player("Naem", Color.WHITE));
        board.set(0, 0, token);
        Assert.assertFalse(board.won());
        board.set(0, 1, token);
        Assert.assertFalse(board.won());
        board.set(0, 2, token);
        Assert.assertTrue(board.won());
        board = new Board(3, 3, new Empty(), conditions);
        board.set(1, 0, token);
        board.set(1, 1, token);
        board.set(1, 2, token);
        Assert.assertTrue(board.won());
        board = new Board(3, 3, new Empty(), conditions);
        board.set(2, 0, token);
        board.set(2, 1, token);
        board.set(2, 2, token);
        Assert.assertTrue(board.won());
    }

    @Test
    public void diagonalTest() {
        conditions.add(new ThreeInARow());
        Board board = new Board(3, 3, new Empty(), conditions);
        IPlayerObject token = new Token(new Player("Naem", Color.WHITE));
        board.set(0, 0, token);
        Assert.assertFalse(board.won());
        board.set(1, 1, token);
        Assert.assertFalse(board.won());
        board.set(2, 2, token);
        Assert.assertTrue(board.won());
        board = new Board(3, 3, new Empty(), conditions);
        board.set(0, 2, token);
        Assert.assertFalse(board.won());
        board.set(1, 1, token);
        Assert.assertFalse(board.won());
        board.set(2, 0, token);
        Assert.assertTrue(board.won());
    }
}
